/****************************************************
*  File: GA.h
*  Purpose: Contains the Genetic Algorithm Logic
*
*  Date:    Author:    Notes:
*  050505   morelli    Initial rev
*
*
*
****************************************************/

#ifndef __GA_H__
#define __GA_H__

#define getrandom( min, max ) ((rand() % (int)(((max) + 1) - (min))) + (min))
#include "Net.h"
#include "TicTacToe.h"

#define XTURN 0
#define OTURN 1

struct Citizen
{
  int * chrom;
  double value;
};

class GA
{
  public:
    GA();
    ~GA();
    int run();
  private:
    int ProcessConfigFile();
    int InitVectors();
    int RunGA();
    double Eval(int * _vec, int _turn);
    void Decode (int * _vec, double * _weights, double * _thresholds);
    void FindMates(Citizen * _cit, int * _mates);
    void XOverMutate(int * _vecA, int * _vecB);
    void DumpStats(double * _values);
    double StaticEval(int * _vec);



/********GA PARAMS***********/
    double crossoverRate;
    double mutationRate;
    int population;
    int vecSize;
    int generations;
/***************************/
/**********TicTacToeParams**/
    int xPly;
    int oPly;
/***************************/

    Citizen * xCitizens;
    Citizen * xCitizensTemp;

    Citizen * oCitizens;
    Citizen * oCitizensTemp;

    int * topX[5];
    int * topO[5];
};






#endif
