/****************************************************
*  File: TicTacToe.h
*  Purpose: Plays a game of tic tac toe
*
*  Date:    Author:    Notes:
*  050505   morelli    Initial rev
*
*
*
****************************************************/




#ifndef __TICTACTOE_H__
#define __TICTACTOE_H__

#include "Net.h"
#include "Board.h"
#include "Patterns.h"
#include "Defs.h"


class TicTacToe
{
  public:
    TicTacToe(Net * _net);
    TicTacToe(Net * _net, Net * _oppNet);
    ~TicTacToe();
    double PlayGame();
    void SetXPly(int _ply);
    void SetOPly(int _ply);
  private:
    int GenerateChildren(Board * _parent, int _turn, 
                         int _depth, int _maxDepth);
    void DumpBoard(Board * _board);
    void PrintBoard(Board * _board);
    int FindMove(Board * _board, int _ply, int _turn);
    void SetLeafValues (Board * _board, int _depth, int _maxDepth, int _turn);
    void SetParentValue (Board * _board, int _depth,
                         int _maxDepth, int _value);
    void InvestigateNodes(Board * _board, int _depth,
                          int _maxDepth, int _type);
    void Pause();
    double StaticEval(Board * _board, bool _final = false);
    int CheckForWinner(Board * _board);


    Board * board;
    Net * pNet;
    Net * pOppNet;
    int xPly;
    int oPly;
};


#endif
